/*******************************************************************************
*  skL6470.c - L6470XebsO[^hCo֐Cu                   *
*                                                                              *
*    L6470_Init    - L6470̏s                                   *
*    L6470_GetRegister - WX^̃f[^ǂݍޏ                        *
*    L6470_SetStep - WX^ɃXebv[hޏ             (v1.10)*
*    L6470_ALARM   - A[̏ǂݍޏ                              *
*    L6470_Run     - [^葬xŉ]鏈                          *
*    L6470_Move    - [^wXebv܂ŉ]鏈                  *
*    L6470_Stop    - [^~鏈                                    *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2016-07-07  ޒH[(ނ)  Create                            *
*  1.10    2021-07-22  ޒH[(ނ)  XebvݒƃA[ON@\ǉ*
* ============================================================================ *
*  PIC 18F2xK22 (̃Cû͑̂ohbłnjƎv܂)             *
*  MPLAB X(v2.15/v5.30)                                                        *
*  MPLAB(R) XC8 C Compiler Version 1.32/2.00                                   *
*******************************************************************************/
#include <xc.h>
#include "skSPIlib.h"
#include "skL6470.h"

int Busy ;

// L6470ɃR}h𑗐M鏈
void CMD_Send(char cmd,unsigned long val,int num)
{
     unsigned char dt[4] ;
     int i ;

     for (i=0 ; i<num ; i++) {
          dt[i] = val & 0xff ;
          val = val >> 8 ;
     }

     L6470_CS = 0 ;
     SPI_transfer(cmd) ;                // R}h̑M
     L6470_CS = 1 ;
     switch (num) {
        case 3:
               L6470_CS = 0 ;
               SPI_transfer(dt[2]) ;    // p[^Q̑M
               L6470_CS = 1 ;
        case 2:
               L6470_CS = 0 ;
               SPI_transfer(dt[1]) ;    // p[^P̑M
               L6470_CS = 1 ;
        case 1:
               L6470_CS = 0 ;
               SPI_transfer(dt[0]) ;    // p[^ȎM
               L6470_CS = 1 ;
               break ;
     }
}
/*******************************************************************************
*  ans = L6470_Init()                                                          *
*    L6470̏s                                                   *
*                                                                              *
*    ans : ݂STATUSԂ                                               *
*******************************************************************************/
unsigned long L6470_Init()
{
     union STEP_MODE_t step_mode ;
     union CONFIG_t config ;
     long  val ;
     int i ;

     // L6470ɃZbg|
     for (i=0 ; i<4 ; i++) {
          L6470_CS = 0 ;
          SPI_transfer(0x00) ;     // NOP̑M
          L6470_CS = 1 ;
     }
     L6470_CS = 0 ;
     SPI_transfer(0xC0) ;          // ResetDeviceR}h̑M
     L6470_CS = 1 ;
     // e탌WX^ɐݒs(SetParam)
     CMD_Send(L6470_ALARM_EN,0xFF,1) ;       // SẴA[M ON ɑI(v1.10)
     CMD_Send(L6470_ACC,0x008A,2) ;          // ̌W(2022.45 Step/s^2)
     CMD_Send(L6470_DEC,0x008A,2) ;          // ̌W(2022.45 Step/s^2)
     CMD_Send(L6470_MAX_SPEED,0x0020,2) ;    // ő]x(503.25 Step/s^2)
     CMD_Send(L6470_MIN_SPEED,0x0001,2) ;    // ŏ]x(0 Step/s^2 ᑬ̍œK@\)
     CMD_Send(L6470_KVAL_HOLD,0xFF,1) ;      // ~̓d(ő 0.996xVs)
     CMD_Send(L6470_KVAL_RUN,0xF0,1) ;       // 葬̓d(ő 0.996xVs)
     CMD_Send(L6470_KVAL_ACC,0xF0,1) ;       // ̓d(ő 0.996xVs)
     CMD_Send(L6470_KVAL_DEC,0xF0,1) ;       // ̓d(ő 0.996xVs)
     CMD_Send(L6470_OCD_TH,0x0F,1) ;         // ߓd臒l(3A)
     CMD_Send(L6470_STALL_TH,0x7F,1) ;       // Xg[d臒l(2A)
      // Xebv[h̐ݒ
     step_mode.DT = 0x07 ;                   // ftHgl
     step_mode.STEP_SEL = FULL_STEP ;        // tXebvɐݒ
     step_mode.SYNC_EN  = Busy = 0 ;         // BUSYo̓[h
     val = step_mode.DT ;
     CMD_Send(L6470_STEP_MODE,val,1) ;
     // RtBO̐ݒ
     config.DT = 0x2F88 ;                    // ftHgl(PWMg:15.6KHz)
     config.OSC_SEL = OSC_INT16MHZ ;         // NbN͓16MHz
     config.EXT_CLK = 0 ;                    // NbNo(OSCOUT)͂Ȃ
     config.SW_MODE = 1 ;                    // n[h~[h
     val = config.DT ;
     CMD_Send(L6470_CONFIG,val,2) ;          // RtBO̐ݒ
     return L6470_GetRegister(L6470_STATUS,2) ;// ݂̃Xe[^XԂB
}
/*******************************************************************************
*  ans = L6470_GetRegister(regadrs,num)                                        *
*    WX^̃f[^ǂݍޏ                                            *
*                                                                              *
*    regadrs : ǂݎ肽WX^̃AhXw(0x01-0x1B)                 *
*    num     : WX^̓ǂݎf[^̃oCg(1-3byte)                     *
*    ans     : ǂݎf[^longlŕԂ                                  *
*******************************************************************************/
unsigned long L6470_GetRegister(char regadrs,int num)
{
     unsigned long ans , dt ;
     int i ;

     L6470_CS = 0 ;
     if (regadrs == L6470_STATUS) SPI_transfer(0xD0) ; // GetStatusR}h̑M
     else SPI_transfer(regadrs|0x20) ;                 // GetParamR}h̑M
     L6470_CS = 1 ;
     ans = dt = 0 ;
     for (i=0 ; i<num ; i++) {
          ans = ans << 8 ;
          L6470_CS = 0 ;
          dt = SPI_transfer(0x00) ;     // X|f[^𓾂ׂɃ_~[̑M
          L6470_CS = 1 ;
          ans = ans | dt ;
     }
     return ans ;
}
/*******************************************************************************
*  L6470_SetStep(mode)                                                 (v1.10) *
*    WX^ɃXebv[hޏ                                    *
*                                                                              *
*    mode : Xebv[hw肵܂                                         *
*******************************************************************************/
void L6470_SetStep(unsigned char mode)
{
     union STEP_MODE_t step_mode ;
     long  val ;

      // Xebv[h̐ݒ
     step_mode.DT = 0x07 ;              // ftHgl
     step_mode.STEP_SEL = mode ;        // w̃Xebvɐݒ
     step_mode.SYNC_EN  = Busy = 0 ;    // BUSYo̓[h
     val = step_mode.DT ;
     CMD_Send(L6470_STEP_MODE,val,1) ;
}
/*******************************************************************************
*  ans = L6470_ALARM()                                                         *
*    A[̏ǂݍޏ                                              *
*    FLAGsLOWɂăA[łA荞݂Ŏ󂯂܂傤B               *
*    ̊֐́AhGetStatushR}h𔭍sĂ̂ŃA[͉܂ *
*                                                                              *
*    ansFA[Ԃ                                           *
*         0=A[͔ĂȂ                                           *
*         3=XCb`Cxgo                                             *
*         7=R}hsłȂ                                             *
*         8=R}hS݂Ȃ                                           *
*         9=do                                                       *
*        10=Mxo                                                       *
*        11=T[}Vbg_Eo                                       *
*        12=ߓdo                                                       *
*        13=`Xg[o                                                 *
*        14=aXg[o                                                 *
*******************************************************************************/
int L6470_ALARM()
{
     unsigned long dt ;
     int i ;

     dt = L6470_GetRegister(L6470_STATUS,2) ;
     for (i=14;i>=9;i--) {
          if ((dt & (1<<i)) == 0) return i ;
     }
     for (i=8;i>=7;i--) {
          if ((dt & (1<<i)) != 0) return i ;
     }
     if ((dt & (1<<3)) != 0) return 3 ;
     return 0 ;
}
/*******************************************************************************
*  L6470_Run(dir,speed)                                                        *
*    [^葬xŉ]鏈                                          *
*    IĂXebsO[hɂ]܂                          *
*                                                                              *
*    dir   : ]w܂(0=t]  1=])                        *
*    speed : ]ڕWxw܂                                    *
*            0.015step/s̕\0(0.015)-104166(15625)̃XebvłB       *
*            MAX_SPEEDႭAMIN_SPEED傫Ȃ΂Ȃ܂B        *
*******************************************************************************/
void L6470_Run(char dir,unsigned long speed)
{
     while( (Busy==0) && (L6470_BUSY==0) ) ; // R}hsȂ҂
     CMD_Send(0x50|dir,speed,3) ;            // 葬x]R}h̑M
}
/*******************************************************************************
*  L6470_Move(dir,step)                                                        *
*    [^wXebv܂ŉ]鏈                                  *
*    IĂXebsO[hɂXebv̉]px͕ς܂B*
*    Ⴆ΁Astep=200ŃtXebv[hȂP](360x)łB               *
*                                                                              *
*    dir   : ]w܂(0=t]  1=])                        *
*    speed : ]ڕWXebvw܂(0-4194303:22bit)             *
*******************************************************************************/
void L6470_Move(char dir,unsigned long step)
{
     while( (Busy==0) && (L6470_BUSY==0) ) ; // R}hsȂ҂
     CMD_Send(0x40|dir,step,3) ;             // ړR}h̑M
}
/*******************************************************************************
*  L6470_Stop(mode)                                                            *
*    [^~鏈                                                    *
*    Hiz̓[^~A[^̏o͂OFF(nCCs[_X)ɂ܂B*
*                                                                              *
*    mode : ~[hw肵܂                                             *
*           0 = SoftStop Ȃ烂[^~܂AێgNLB    *
*           1 = HardStop Ƀ[^~܂AێgNLB          *
*           2 = SoftHiz  Ȃ烂[^~܂AێgNB    *
*           3 = HardHiz  Ƀ[^~܂AێgNB          *
*******************************************************************************/
void L6470_Stop(int mode)
{
     unsigned char cmd[4] = {0xB0,0xB8,0xA0,0xA8} ;

     while( (Busy==0) && (L6470_BUSY==0) ) ; // R}hsȂ҂
     L6470_CS = 0 ;
     SPI_transfer(cmd[mode]) ;               // XgbvR}h̑M
     L6470_CS = 1 ;
}
