/*******************************************************************************
*  skL6470.h - L6470XebsO[^hCo֐Cupwb_t@C   *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2016-07-07  ޒH[(ނ)  Create                            *
*  1.10    2021-07-22  ޒH[(ނ)  XebvݒƃA[ON@\ǉ*
* ============================================================================ *
*  PIC 18F2xK22                                                                *
*  MPLAB X(v2.15/v5.30)                                                        *
*  MPLAB(R) XC8 C Compiler Version 1.32/2.00                                   *
*******************************************************************************/
#ifndef _SKL6470_H_
#define _SKL6470_H_

#ifndef _XTAL_FREQ
 // Unless already defined assume 64MHz system frequency
 // This definition is required to calibrate __delay_us() and __delay_ms()
 #define _XTAL_FREQ 64000000       // gpPICɂ蓮glݒ肷
#endif

#define L6470_CS	LATC2	        // L6470SPI-CS̃sԍ
#define L6470_BUSY	PORTBbits.RB4	// L6470BUSỸsԍ

// WX^̃AhX
#define L6470_ACC	0x05	// ̌W(12bit)
#define L6470_DEC	    0x06	// ̌W(12bit)
#define L6470_MAX_SPEED	0x07	// ő]x(10bit)
#define L6470_MIN_SPEED	0x08	// ŏ]x(13bit)
#define L6470_KVAL_HOLD	0x09	// ~̓d(8bit)
#define L6470_KVAL_RUN	0x0A	// 葬]̓d(8bit)
#define L6470_KVAL_ACC	0x0B	// ̓d(8bit)
#define L6470_KVAL_DEC	0x0C	// ̓d(8bit)
#define L6470_OCD_TH	0x13	// ߓd臒l(4bit)
#define L6470_STALL_TH	0x14	// Xg[d臒l(7bit)
#define L6470_STEP_MODE	0x16	// Xebv[h̐ݒ(8bit)
#define L6470_ALARM_EN	0x17	// eA[̗Lݒ(8bit)
#define L6470_CONFIG	0x18	// RtBO̐ݒ(16bit)
#define L6470_STATUS	0x19	// ݂̃Xe[^X(16bit)

// 萔̒`
#define Forward         1       // [^͐]ŉ]
#define Reverse         0       // [^͋t]ŉ]
#define SOFTSTOP        0       // ~AێgNL
#define HARDSTOP        1       // ~AێgNL
#define SOFTHIZ         2       // ~AێgN
#define HARDHIZ         3       // ~AێgN
#define FULL_STEP	0	// tXebv([^ƓXebv)
#define HALF_STEP	1	// n[tXebv([^ƓXebvx2)
#define MICROSTEP8	3	// 1/8 }CNXebv([^ƓXebvx8)
#define MICROSTEP64	6	// 1/64  }CNXebv([^ƓXebvx64)
#define MICROSTEP128	7	// 1/128 }CNXebv([^ƓXebvx128)
#define OSC_INT16MHZ    0       // NbN͓16MHz


// WX^̍\̒`
// STEP_MODE Register
union STEP_MODE_t {           // XebsO[hWX^(ftHg=0x07)
     unsigned char DT ;
     struct {
          unsigned STEP_SEL   :3 ;      // XebsO[h̐ݒ
          unsigned SP         :1 ;      // \
          unsigned SYNC_SEL   :3 ;      // g̑I
          unsigned SYNC_EN    :1 ;      // BUSY/SYNC̑I
     } ;
} ;
// CONFIG Register
union CONFIG_t {              // RtBOWX^(ftHg=0x2E88)
     unsigned int DT ;
     struct {
          unsigned OSC_SEL    :3 ;      // NbN̑I
          unsigned EXT_CLK    :1 ;      // NbNo̗͂L
          unsigned SW_MODE    :1 ;      // SW@\̑I
          unsigned EN_VSCPMP  :1 ;      // [^̓dd⏞̗L
          unsigned SP         :1 ;      // \
          unsigned OC_SD      :1 ;      // ߓd̃ubWH~̗L
          unsigned POW_SR     :2 ;      // [^o͂̃X[[gl̐ݒ
          unsigned F_PWM_DEC  :3 ;      // PWMg̐ݒ
          unsigned F_PWM_INT  :3 ;      // PWMg{ݒ
     } ;
} ;


// ֐̃vg^Cv錾
unsigned long L6470_Init() ;
unsigned long L6470_GetRegister(char regadrs,int num) ;
void L6470_SetStep(unsigned char mode) ;                // (v1.10)
int  L6470_ALARM() ;
void L6470_Run(char dir,unsigned long speed) ;
void L6470_Move(char dir,unsigned long step) ;
void L6470_Stop(int mode) ;

#endif
